#include <stdio.h>
#include <stdlib.h>

struct iscritto{
       char cognome[30];
       char nome[30];
       int codice;
       int tipo;
       };

struct prenota{
       int iscritto;
       int servizio;
       int durata;
       int giorno;
       };

struct atomo{
       struct prenota dato;
       struct atomo *next;
       };

/*1 FUNZIONE INSERIMENTO ORDINATO , PASSIAMO L'INTERA TABELLA FATTA
DA 4 RIGHE UNA PER OGNI TIPO E DEVE ESSERE FATTO L'INSERIMENTO ORDINATO*/
void inserimento(struct iscritto *T[4],int N[4],struct iscritto x)
{
     struct iscritto *aux;
     int i,j,p;


     /*Allocazione dinamica della memoria*/
     j=x.tipo;

     aux=realloc(T[j],sizeof(struct iscritto)*(N[j]+1));
     if(aux!=NULL)
     {
       T[j]=aux; /*dobbiamo applicare l'algoritmo dell'inserimento ordinato*/
     /*Inserimento ordinato rispetto al campo codice*/
       for(i=0;i<N[j];i++)
             if(x.codice<T[j][i].codice) /*Facciamo l'ordinamento rispetto al codice*/
             break;

	   for(p=N[j];p>i;p--)
              T[j][p]=T[j][p-1];

         T[j][i]=x;
         N[j]++;
     }

}
/*2 FUNZIONE , RICERCA BINARIA*/
int ricerca(struct iscritto *T[4], int N[4],int codice,int tipo)
{
    int inf,sup,med;
    inf=0;
    sup=N[tipo]-1;

    while(inf<=sup)
    {
       med=(inf+sup)/2;
       if(T[tipo][med].codice==codice)
             return 1;/*trovato*/
       else if(T[tipo][med].codice<codice)
              inf=med+1;
       else sup=med-1;
    }
    return 0; /*non trovato*/
}

/*3 FUNZIONE , RICERCA E INSERIMENTO ,DOBBIAMO
SCRIVERE LA FUNZIONE CHE FA L'INSERIMENTO IN TESTA ALLA LISTA*/
void in_testa(struct atomo **testa,struct prenota p)
{
     struct atomo *a;

     a=malloc(sizeof(struct atomo));
     if(a)
     {    a->dato=p;
          a->next=*testa;
          *testa=a;
     }
}

/*4FUNZIONE ,ELIMINAZIONE DOPO VISUALIZZAZIONE, E' COME SE RIPETIAMO
TANTE VOLTE LA FUNZIONE DA_TESTA*/
void elimina(struct atomo **testa)
{
     struct atomo *a;

     while(*testa !=NULL) /*fino a quando la lista non  vuota*/
     {
       a=*testa;
       *testa=a->next;
       printf("Codice servizio %d\n",a->dato.servizio);
       printf("Giorno servizio %d\n",a->dato.giorno);
       free(a);
     }
}

/*5 FUNZIONE, SALVA*/
void salva(struct iscritto *T[4], int N[4])
{
     FILE *pf;
     int i,j;

     pf=fopen("iscritti.txt","w");
     if(pf)
     {
         for(i=0;i<4;i++)
           for(j=0;j<N[i];j++)
            fwrite(&T[i][j],sizeof(struct iscritto),1,pf);
         fclose(pf);
     }
}

  /*6 FUNZIONE INIZIALIZZAZIONE*/
void inizializza(struct iscritto *T[4],int N[4])
{
     FILE *pf;
     struct iscritto x;

     pf=fopen("iscritti.txt","r");
     if(pf)
     {
           while(fread(&x,sizeof(struct iscritto),1,pf))
           inserimento(T,N,x); /*con questo il valore che legge lo inserisce nella tabella*/
           fclose(pf);
     }
     else printf("Il file non esiste\n");
}

main()
{
      struct iscritto *TB[4],x;
      int N[4];
      /*passiamo alla lista*/
      struct atomo *Lista[6];
      int i,codice;
      int scelta;
      struct prenota p;
      /*1 inizializziamo*/
      for(i=0;i<6;i++)
      Lista[i]=NULL;

      for(i=0;i<4;i++)
      {
                      TB[i]=NULL;
                      N[i]=0;
      }
      inizializza(TB,N);
      do{
         printf("\nScegli tra\n");
         printf("1) Nuovo iscritto\n2)Ricerca iscritto\n");
         printf("3) Prenota servizio4)Elimina prenotazione\n");
         printf("5) Salva iscritti\n0)Fine\n\n");
         scanf("%d",&scelta);

         switch(scelta)
         {
             case 1: printf("Cognome\n");
                     scanf("%s",x.cognome);
                     printf("Nome\n");
                     scanf("%s",x.nome);
                     printf("Codice identificativo\n");
                     scanf("%d",&x.codice);
                     printf("Tipo (0,1,2,3)");
                     scanf("%d",&x.tipo);
                     inserimento(TB,N,x);
                     break;
             case 2: printf("Codice identificativo\n");
                     scanf("%d",&codice);
                     printf("Tipo (0,1,2,3)\n");
                     scanf("%d",&i);
                     /*RICERCA*/
                     if(ricerca(TB,N,codice,i)==1)
                           printf("Trovato\n");
                      else printf("Non trovato\n");
                     break;
             case 3: /*Inserimento in lista dopo la
                       verifica della presenza dell'iscritto*/

                     /*RIPETIAMO LA PARTE INIZIALE DEL PUNTO 2*/
                     printf("Codice identificativo\n");
                     scanf("%d",&codice);
                     printf("Tipo (0,1,2,3)\n");
                     scanf("%d",&i);
                     /*RICERCA*/
                     if(ricerca(TB,N,codice,i)==1)
                     /*Se l'iscritto  stato trovato*/
                     {
                       p.iscritto=codice;
                       printf("Codice servizio\n");
                       scanf("%d",&p.servizio);
                       printf("Giorno (0..5)\n");
                       scanf("%d",&p.giorno);
                       printf("Durata (Num.ore)\n");
                       scanf("%d",&p.durata);
                       in_testa(&Lista[p.giorno],p);
                     }
                     else printf("Non iscritto\n");
                     break;
             case 4: printf("Lista da cancellare ");
                     scanf("%d",&i);
                     elimina(&Lista[i]);
                     break;
             case 5: salva(TB,N);
                     break;
             default:; }
             } while(scelta!=0);

                        /* liberiamo la memoria */
             for(i=0;i<4;i++)
                free(TB[i]);

             for(i=0;i<6;i++)
                elimina(&Lista[i]);
}



